## awesome 4.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.0)
set(CMAKE_ALLOW_LOOSE_LOOP_CONSTRUCTS  TRUE)

if(COMMAND cmake_policy)
    cmake_policy(VERSION 2.6)
endif()

set(SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})
set(BUILD_DIR ${CMAKE_CURRENT_BINARY_DIR})

if(NOT EXISTS ${SOURCE_DIR}/awesomeConfig.cmake)
    message(FATAL_ERROR "Please provide awesomeConfig.cmake")
endif()

# Define many variables

include(awesomeConfig.cmake)

include_directories(
    ${BUILD_DIR}
    ${AWESOME_COMMON_REQUIRED_INCLUDE_DIRS}
    ${AWESOME_REQUIRED_INCLUDE_DIRS}
    ${AWESOME_OPTIONAL_INCLUDE_DIRS})

set(CHECK_TARGETS check-integration)

set(AWE_CONF_FILE_DEFAULT ${BUILD_DIR}/awesomerc.lua)
set(AWE_CONF_FILE rc.lua)

set(AWE_ICON_DIR ${SOURCE_DIR}/icons)
set(AWE_THEMES_DIR ${SOURCE_DIR}/themes)

set(AWE_DOC_DIR ${BUILD_DIR}/docs)

set(AWE_DOC_FILES
    ${AWE_DOC_DIR}/00-authors.md
    ${AWE_DOC_DIR}/01-readme.md
    ${AWE_DOC_DIR}/02-contributing.md
    ${SOURCE_DIR}/LICENSE)

set(AWE_SRCS
    ${BUILD_DIR}/awesome.c
    ${BUILD_DIR}/banning.c
    ${BUILD_DIR}/color.c
    ${BUILD_DIR}/dbus.c
    ${BUILD_DIR}/draw.c
    ${BUILD_DIR}/event.c
    ${BUILD_DIR}/ewmh.c
    ${BUILD_DIR}/keygrabber.c
    ${BUILD_DIR}/luaa.c
    ${BUILD_DIR}/mouse.c
    ${BUILD_DIR}/mousegrabber.c
    ${BUILD_DIR}/property.c
    ${BUILD_DIR}/root.c
    ${BUILD_DIR}/selection.c
    ${BUILD_DIR}/spawn.c
    ${BUILD_DIR}/stack.c
    ${BUILD_DIR}/strut.c
    ${BUILD_DIR}/systray.c
    ${BUILD_DIR}/xwindow.c
    ${BUILD_DIR}/xkb.c
    ${BUILD_DIR}/xrdb.c
    ${BUILD_DIR}/common/atoms.c
    ${BUILD_DIR}/common/backtrace.c
    ${BUILD_DIR}/common/buffer.c
    ${BUILD_DIR}/common/luaclass.c
    ${BUILD_DIR}/common/lualib.c
    ${BUILD_DIR}/common/luaobject.c
    ${BUILD_DIR}/common/util.c
    ${BUILD_DIR}/common/version.c
    ${BUILD_DIR}/common/xcursor.c
    ${BUILD_DIR}/common/xembed.c
    ${BUILD_DIR}/common/xutil.c
    ${BUILD_DIR}/objects/button.c
    ${BUILD_DIR}/objects/client.c
    ${BUILD_DIR}/objects/drawable.c
    ${BUILD_DIR}/objects/drawin.c
    ${BUILD_DIR}/objects/key.c
    ${BUILD_DIR}/objects/screen.c
    ${BUILD_DIR}/objects/tag.c
    ${BUILD_DIR}/objects/window.c)

set(AWE_MAN_SRCS
    ${SOURCE_DIR}/manpages/awesome.1.txt
    ${SOURCE_DIR}/manpages/awesome-client.1.txt
    ${SOURCE_DIR}/manpages/awesomerc.5.txt)
set(AWE_MAN_LANGS it es fr de ru)

# Don't strip RPATH if compiling on Solaris
if (${CMAKE_SYSTEM_NAME} MATCHES "SunOS")
    set(CMAKE_SKIP_BUILD_RPATH FALSE)
    set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
    set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
endif()

add_executable(${PROJECT_AWE_NAME}
    ${AWE_SRCS})

# CFLAGS
set(AWESOME_C_FLAGS
    -O1 -std=gnu99 -ggdb3 -fno-strict-aliasing -Wall -Wextra
    -Wchar-subscripts -Wundef -Wshadow -Wcast-align -Wwrite-strings
    -Wsign-compare -Wunused -Wno-unused-parameter -Wuninitialized -Winit-self
    -Wpointer-arith -Wformat-nonliteral
    -Wno-format-zero-length -Wmissing-format-attribute -Wmissing-prototypes
    -Wstrict-prototypes
    CACHE STRING "CFLAGS used to compile ${PROJECT_AWE_NAME}")
mark_as_advanced(AWESOME_C_FLAGS)
target_compile_options(${PROJECT_AWE_NAME} PRIVATE ${AWESOME_C_FLAGS})

# Make sure awesomerc.lua is generated
add_dependencies(${PROJECT_AWE_NAME} generate_awesomerc)

# Linux w/ GCC requires -rdynamic to get backtrace to fully work.
#
# For "historical reasons", CMake adds the option to the linker flags
# unnoticeably for Linux w/ GCC through its modules Linux-GNU.cmake
# and Linux-GNU-C.cmake.  Our build system has counted on that.  But
# just in case CMake should do away with the convention suddenly...
if(DEFINED CMAKE_SHARED_LIBRARY_LINK_C_FLAGS AND
        NOT CMAKE_SHARED_LIBRARY_LINK_C_FLAGS MATCHES "-rdynamic")
    target_link_libraries(${PROJECT_AWE_NAME}
        $<$<AND:$<PLATFORM_ID:Linux>,$<C_COMPILER_ID:GNU>>:-rdynamic>)
endif()

# FreeBSD requires dynamic linking
if(${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
    set_target_properties(${PROJECT_AWE_NAME}
        PROPERTIES
        LINK_FLAGS -export-dynamic)
endif()

target_link_libraries(${PROJECT_AWE_NAME}
    ${AWESOME_COMMON_REQUIRED_LDFLAGS}
    ${AWESOME_REQUIRED_LDFLAGS}
    ${AWESOME_OPTIONAL_LDFLAGS})

# check for lgi and the needed gobject introspection files
add_custom_target(lgi-check ALL
    COMMAND ${SOURCE_DIR}/build-utils/lgi-check.sh)

# {{{ Generated sources
# atoms
file(MAKE_DIRECTORY ${BUILD_DIR}/common)
add_custom_command(
    COMMAND ${SOURCE_DIR}/build-utils/atoms-ext.sh ${SOURCE_DIR}/common/atoms.list
    ARGS    > ${BUILD_DIR}/common/atoms-extern.h
    OUTPUT  ${BUILD_DIR}/common/atoms-extern.h
    WORKING_DIRECTORY ${SOURCE_DIR}
    DEPENDS ${SOURCE_DIR}/common/atoms.list
    COMMENT "Generating atoms-extern.h"
    VERBATIM)

add_custom_command(
    COMMAND ${SOURCE_DIR}/build-utils/atoms-int.sh ${SOURCE_DIR}/common/atoms.list
    ARGS    > ${BUILD_DIR}/common/atoms-intern.h
    OUTPUT  ${BUILD_DIR}/common/atoms-intern.h
    WORKING_DIRECTORY ${SOURCE_DIR}
    DEPENDS ${SOURCE_DIR}/common/atoms.list
    COMMENT "Generating atoms-intern.h"
    VERBATIM)

add_custom_target(generated_sources
    DEPENDS ${BUILD_DIR}/common/atoms-intern.h
            ${BUILD_DIR}/common/atoms-extern.h)

# Default theme directory
file(MAKE_DIRECTORY ${BUILD_DIR}/themes/default)
file(MAKE_DIRECTORY ${BUILD_DIR}/themes/sky)
file(MAKE_DIRECTORY ${BUILD_DIR}/themes/zenburn)
file(MAKE_DIRECTORY ${BUILD_DIR}/themes/xresources)
add_dependencies(${PROJECT_AWE_NAME} generated_sources)
# }}}

# {{{ Version stamp
if(BUILD_FROM_GIT)
    add_custom_target(version_stamp ALL
        COMMAND ${SOURCE_DIR}/build-utils/git-version-stamp.sh
                ${VERSION_STAMP_FILE}
                ${BUILD_DIR}/awesome-version-internal.h
        WORKING_DIRECTORY ${SOURCE_DIR})

    add_dependencies(${PROJECT_AWE_NAME} version_stamp)
endif()
# }}}

# {{{ Manpages
if(GENERATE_MANPAGES)
    if(NOT BUILD_DIR STREQUAL SOURCE_DIR)
        file(MAKE_DIRECTORY ${BUILD_DIR}/manpages)
    endif()

    # add the default translation to the list of languages
    set(AWE_MAN_LANGS default ${AWE_MAN_LANGS})

    foreach(lang ${AWE_MAN_LANGS})

        foreach(txtfile ${AWE_MAN_SRCS})
            # figure the base name of the file (ie "awesome.1")
            GET_FILENAME_COMPONENT(tmpname ${txtfile} NAME)
            string(REGEX REPLACE ".txt\$" "" basename ${tmpname})

            # figure the relative path of the file
            GET_FILENAME_COMPONENT(tmppath ${txtfile} PATH)
            string(REPLACE ${SOURCE_DIR}/ "" relpath ${tmppath})

            # figure the manpage section to install to from filename
            string(REGEX REPLACE "^.*\\.([0-9])$" "\\1" section ${basename})

            # construct the language specific versions of the basename and path
            if (lang STREQUAL default)
                set(basename2 ${basename})
                set(relpath2 ${relpath}/man${section})
            else()
                set(basename2 ${basename}.${lang})
                set(relpath2 ${relpath}/${lang}/man${section})
            endif()

            # create the build directory (if it does not exist)
            file(MAKE_DIRECTORY ${BUILD_DIR}/${relpath2})

            # set the final filenames
            set(txtfile ${SOURCE_DIR}/${relpath}/${basename2}.txt)
            set(xmlfile ${BUILD_DIR}/${relpath2}/${basename}.xml)
            set(gzfile  ${BUILD_DIR}/${relpath2}/${basename}.gz)
            set(manfile ${BUILD_DIR}/${relpath2}/${basename})

            add_custom_command(
                COMMAND ${ASCIIDOC_EXECUTABLE} -d manpage -b docbook -o ${xmlfile} - < ${txtfile}
                WORKING_DIRECTORY ${BUILD_DIR}/${relpath2}
                OUTPUT  ${xmlfile}
                DEPENDS ${txtfile}
                VERBATIM)
            add_custom_command(
                COMMAND ${XMLTO_EXECUTABLE} man ${xmlfile}
                OUTPUT  ${manfile}
                WORKING_DIRECTORY ${BUILD_DIR}/${relpath2}
                DEPENDS ${xmlfile})

            if(COMPRESS_MANPAGES)
                add_custom_command(
                    COMMAND ${GZIP_EXECUTABLE} < ${manfile} > ${gzfile}
                    OUTPUT  ${gzfile}
                    WORKING_DIRECTORY ${BUILD_DIR}/${relpath2}
                    DEPENDS ${manfile}
                    VERBATIM)

                set(MAN_FILES ${MAN_FILES} ${gzfile})
            else()
                set(MAN_FILES ${MAN_FILES} ${manfile})
            endif()
        endforeach()

    endforeach()

    add_custom_target(man ALL DEPENDS ${MAN_FILES})
endif()
# }}}

# {{{ Lua API Documentation
if(GENERATE_DOC)

    if(NOT BUILD_DIR STREQUAL SOURCE_DIR)
        file(MAKE_DIRECTORY ${BUILD_DIR}/lib)
        file(MAKE_DIRECTORY ${BUILD_DIR}/doc)
    endif()

    file(GLOB_RECURSE AWE_LUA_FILES ${BUILD_DIR}/lib/*.lua)
    file(GLOB_RECURSE AWE_MD_FILES ${AWE_DOC_DIR}/*.md)
    file(GLOB_RECURSE AWE_MD_LUA_FILES RELATIVE "${SOURCE_DIR}/docs" docs/*.md.lua)
    foreach(file ${AWE_MD_LUA_FILES})
        # Remove .lua file extensions
        string(REPLACE ".lua" "" file ${file})
        list(APPEND AWE_MD_FILES "${AWE_DOC_DIR}/${file}")
    endforeach()

    # Copy the images to the build directory
    file(COPY ${SOURCE_DIR}/docs/images DESTINATION ${BUILD_DIR}/doc)

    # Copy the aliases to the build directory
    file(COPY ${SOURCE_DIR}/docs/aliases DESTINATION ${BUILD_DIR}/docs)

    add_custom_target(ldoc ALL
        COMMAND ${LDOC_EXECUTABLE} .
        WORKING_DIRECTORY ${AWE_DOC_DIR}
        DEPENDS ${AWE_LUA_FILES} ${AWE_MD_FILES}
    )

    # Run ldoc and make it fail if any warnings are generated. The
    # redirection-magic swaps stdout and stderr and awk exits with a non-zero
    # status if it sees at least one line of input.
    # All together, this fails as soon as ldoc prints on stderr.
    add_custom_target(check-ldoc-warnings
        COMMAND ${LDOC_EXECUTABLE} . 3>&1 1>&2 2>&3 | awk "{ fail=1 \; print } END { exit fail }"
        WORKING_DIRECTORY ${AWE_DOC_DIR}
        DEPENDS ${AWE_LUA_FILES} ${AWE_MD_FILES}
    )
    list(APPEND CHECK_QA_TARGETS check-ldoc-warnings)
endif()
# }}}

# {{{ Theme icons
file(GLOB icon_sources RELATIVE ${SOURCE_DIR} ${SOURCE_DIR}/themes/*/titlebar/*.png)

foreach(icon ${icon_sources})
    # Copy all icons to the build dir to simplify the following code.
    # Source paths are interpreted relative to ${SOURCE_DIR}, target paths
    # relative to ${BUILD_DIR}.
    get_filename_component(icon_path ${icon} PATH)
    get_filename_component(icon_name ${icon} NAME)
    file(COPY ${icon} DESTINATION ${icon_path})
    set(ALL_ICONS ${ALL_ICONS} "${icon_path}/${icon_name}")
endforeach()

macro(a_icon_convert match replacement input)
    string(REPLACE ${match} ${replacement} output ${input})

    if(NOT ${input} STREQUAL ${output} AND NOT ";${ALL_ICONS};" MATCHES ";${output};")
        set(ALL_ICONS ${ALL_ICONS} ${output})

        add_custom_command(
            COMMAND ${CONVERT_EXECUTABLE} ${input} -strip ${ARGN} ${output}
            OUTPUT  ${output}
            DEPENDS ${input}
            VERBATIM)
    endif()
endmacro()

foreach(icon ${ALL_ICONS})
    # Make unfocused icons translucent
    a_icon_convert("_focus" "_normal" ${icon}
        -colorspace rgb -gamma 0.6 -channel A -evaluate Multiply 0.4)
endforeach()

foreach(icon ${ALL_ICONS})
    # Make inactive icons grayscale
    a_icon_convert("_active" "_inactive" ${icon}
        -colorspace Gray)
endforeach()

add_custom_target(generated_icons ALL DEPENDS ${ALL_ICONS})
# }}}

# {{{ Dist tarball
if(BUILD_FROM_GIT)
    add_custom_target(dist
        COMMAND ${SOURCE_DIR}/build-utils/dist.sh ${VERSION}
        WORKING_DIRECTORY ${SOURCE_DIR})
endif()
# }}}

# {{{ Installation
install(TARGETS ${PROJECT_AWE_NAME} RUNTIME DESTINATION bin)
install(FILES "utils/awesome-client" DESTINATION bin PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)
install(DIRECTORY ${BUILD_DIR}/lib DESTINATION ${AWESOME_DATA_PATH}

=== Makefile ===
builddir=.build-$(shell hostname)-$(shell gcc -dumpmachine)-$(shell gcc -dumpversion)

ifeq (,$(VERBOSE))
    MAKEFLAGS:=$(MAKEFLAGS)s
    ECHO=echo
else
    ECHO=@:
endif

TARGETS=awesome
BUILDLN=build

all: $(TARGETS) $(BUILDLN) ;

$(TARGETS): cmake-build
	ln -s -f ${builddir}/$@ $@

$(BUILDLN):
	test -e $(BUILDLN) || ln -s -f ${builddir} $(BUILDLN)

cmake ${builddir}/CMakeCache.txt:
	mkdir -p ${builddir}
	$(ECHO) "Running cmake…"
	cd ${builddir} && cmake $(CMAKE_ARGS) "$(@D)" ..

cmake-build: ${builddir}/CMakeCache.txt
	$(ECHO) "Building…"
	$(MAKE) -C ${builddir}

tags:
	git ls-files | xargs ctags

install:
	$(ECHO) "Installing…"
	$(MAKE) -C ${builddir} install

distclean:
	$(ECHO) -n "Cleaning up build directory…"
	$(RM) -r ${builddir} $(BUILDLN) $(TARGETS)
	$(ECHO) " done"

%: cmake
	$(ECHO) "Running make $@…"
	$(MAKE) -C ${builddir} $@
	$(and $(filter clean,$@),$(RM) $(BUILDLN) $(TARGETS))

.PHONY: cmake-build cmake install distclean $(BUILDLN) tags

=== tests/examples/CMakeLists.txt ===
# This module is designed to allow the Awesome documentation examples to be
# tested.
#
# It shims enough of the Awesome C API to allow code to be executed without an
# actual X server or running Awesome process. These tests are not genuine
# integration tests, but they are the next best thing.
#
# As secondary goals, this module also generates images of the test result
# where relevant. Those images are used by the documentation and help the
# developers track user interface regressions and glitches. Finally, it also
# helps to find broken code.
cmake_minimum_required(VERSION 3.0.0)

# Get and update the LUA_PATH so the scripts can be executed without Awesome.
execute_process(COMMAND lua -e print\(package.path\) OUTPUT_VARIABLE "LUA_PATH_")

# Add the main awesome lua libraries.
set(LUA_PATH2_ "\
${CMAKE_SOURCE_DIR}/lib/?.lua;\
${CMAKE_SOURCE_DIR}/lib/?/init.lua;\
${CMAKE_SOURCE_DIR}/lib/?;\
${CMAKE_SOURCE_DIR}/themes/?.lua;\
${CMAKE_SOURCE_DIR}/themes/?;"
)

# Add the C API shims.
set(LUA_PATH3_ "\
${CMAKE_SOURCE_DIR}/tests/examples/shims/?.lua;\
${CMAKE_SOURCE_DIR}/tests/examples/shims/?/init.lua;\
${CMAKE_SOURCE_DIR}/tests/examples/shims/?;"
)

# Done in 3 variables to avoid CMake from implicitly converting into a list.
set(ENV{LUA_PATH} "${LUA_PATH3_}${LUA_PATH2_}${LUA_PATH_}")

# Unset environment variables that would get in the way of evaluating LUA_PATH.
unset(ENV{LUA_PATH_5_1})
unset(ENV{LUA_PATH_5_2})
unset(ENV{LUA_PATH_5_3})

# The documentation images directory.
set(IMAGE_DIR "${CMAKE_BINARY_DIR}/doc/images")
file(MAKE_DIRECTORY "${IMAGE_DIR}")

# Escape potentially multiline strings to be part of the API doc.
#  * add "--" in front of each lines
#  * add a custom prefix in front of each lines
#  * drop empty lines
#  * convert " " lines into empty lines
#  * drop lines ending with "--DOC_SOMETHING", they are handled elsewhere
function(escape_string variable content escaped_content line_prefix)
    # If DOC_HIDE_ALL is present, do nothing.
    if(variable MATCHES "--DOC_HIDE_ALL")
        return()
    endif()
    string(REGEX REPLACE "\n" ";" var_lines "${variable}")

    set(tmp_output ${content})
    foreach (LINE ${var_lines})
        if(NOT LINE MATCHES "^.+--DOC_[A-Z]+$")
            set(tmp_output ${tmp_output}\n--${line_prefix}${LINE})
        endif()
    endforeach()

    set(${escaped_content} ${tmp_output} PARENT_SCOPE)
endfunction()

# Extract lines with the --DOC_HEADER marker.
function(extract_header variable pre_output post_output)
    string(REGEX REPLACE "\n" ";" var_lines "${variable}")

    set(IS_POST 0)

    foreach (LINE ${var_lines})
        # This function doesn't escape the lines, so make sure they are
        # already comments.
        if(LINE MATCHES "^--.*--DOC_HEADER")
            # Remove the header tag
            string(REGEX REPLACE "[ ]*--DOC_HEADER" "" LINE "${LINE}")

            # ldoc is picky about what happens after the first --@, so split
            # the output on that.
            if (NOT IS_POST AND LINE MATCHES "^--[ ]*@")
                set(IS_POST 1)
            endif()

            if (IS_POST)
                set(tmp_post_output ${tmp_post_output}\n${line_prefix}${LINE})
            else()
                set(tmp_pre_output ${tmp_pre_output}\n${line_prefix}${LINE})
            endif()
        endif()
    endforeach()

    set(${post_output} "${tmp_post_output}\n--" PARENT_SCOPE)
    set(${pre_output} "${tmp_pre_output}\n--" PARENT_SCOPE)
endfunction()

# Read a code file and convert it to ldoc usage example.
#  * add "--" in front of each lines
#  * drop empty lines
#  * convert " " lines into empty lines
#  * drop lines ending with "--DOC_HIDE"
function(escape_code path escaped_content pre_header post_header)
    file(READ ${path} path)

    escape_string("${path}\n" "" escaped_code "")

    extract_header("${path}" example_pre_header example_post_header)

    set(${escaped_content} ${escaped_code} PARENT_SCOPE)
    set(${pre_header} ${example_pre_header} PARENT_SCOPE)
    set(${post_header} ${example_post_header} PARENT_SCOPE)
endfunction()

# Find the template.lua that is closest to the given file. For example, if a
# template.lua is present in the same directory, its path will be returned. If
# one is present in the parent directory, that path is returned etc.
function(find_template result_variable file)
    get_filename_component(path "${file}" DIRECTORY)

    while(NOT EXISTS "${path}/template.lua")
        set(last_path "${path}")
        get_filename_component(path "${path}" DIRECTORY)
        if(last_path STREQUAL path)
            message(FATAL_ERROR "Failed to find template.lua for ${file}")
        endif()
    endwhile()

    set(${result_variable} "${path}/template.lua" PARENT_SCOPE)
endfunction()

# Get the namespace of a file.
function(get_namespace result_variable file)
    get_filename_component(path "${file}" DIRECTORY)
    string(LENGTH "${SOURCE_DIR}/tests/examples" prefix_length)
    string(REPLACE "/" "_" namespace "${path}")
    string(SUBSTRING "${namespace}" "${prefix_length}" -1 namespace)

    set(${result_variable} "${namespace}" PARENT_SCOPE)
endfunction()

# Execute a Lua file.
function(run_test test_path namespace escaped_content)
    find_template(template "${test_path}")

    # Get the file name without the extension.
    get_filename_component(${test_path} TEST_FILE_NAME NAME)
    set(IMAGE_PATH "${IMAGE_DIR}/AUTOGEN${namespace}_${TEST_FILE_NAME}")

    # Use the example testing as coverage source.
    if (USE_LCOV)
        set(LCOV_PATH ${SOURCE_DIR}/.luacov)
    endif()

    # Execute the script, leave the image extension decision to the test.
    # SVG is preferred, but PNG is better suited for some tests, like bitmap
    # patterns.
    execute_process(
        COMMAND lua ${template} ${test_path} ${IMAGE_PATH} ${LCOV_PATH}
        OUTPUT_VARIABLE TEST_OUTPUT
        ERROR_VARIABLE  TEST_ERROR
    )

    # If there is something on stderr, exit.
    if (NOT TEST_ERROR STREQUAL "")
        message("${TEST_OUTPUT}")
        message("${TEST_ERROR}")
        if (STRICT_TESTS)
            message(FATAL_ERROR ${test_path} " An example test failed, aborting.")
        endif()
    endif()

    # Read the code and turn it into an usage example.
    escape_code(${test_path} TEST_CODE TEST_PRE_HEADER TEST_POST_HEADER)

    # Build the documentation.
    set(TEST_DOC_CONTENT "${TEST_PRE_HEADER}")

    # If the image has been created, then add it.
    if(EXISTS "${IMAGE_PATH}.svg")
        escape_string(
            "![Usage example](../images/AUTOGEN${namespace}_${TEST_FILE_NAME}.svg)\n"
            "${TEST_DOC_CONTENT}" TEST_DOC_CONTENT ""
        )
    elseif(EXISTS "${IMAGE_PATH}.png")
        escape_string(
            "![Usage example](../images/AUTOGEN${namespace}_${TEST_FILE_NAME}.png)\n"
            "${TEST_DOC_CONTENT}" TEST_DOC_CONTENT ""
        )
    endif()

    # If there is an output, assume it is relevant and add it to the
    # documentation under the image.
    if(NOT ${TEST_OUTPUT} STREQUAL "")
        set(TEST_DOC_CONTENT
            "${TEST_DOC_CONTENT}\n--\n--**Usage example output**:\n--"
        )

        # Markdown requires an empty line before and after, and 4 spaces.
        escape_string(
            "\n${TEST_OUTPUT}"
            "${TEST_DOC_CONTENT}" TEST_DOC_CONTENT "    "
        )
        set(TEST_DOC_CONTENT "${TEST_DOC_CONTENT}\n--")
    endif()

    # If there is some @* content, append it.
    set(TEST_DOC_CONTENT "${TEST_DOC_CONTENT}${TEST_POST_HEADER}")

    # Only add it if there is something to display.
    if(NOT ${TEST_CODE} STREQUAL "\n--")
        # Do not use the @usage tag, but 4 spaces.
        file(READ ${test_path} tmp_content)
        if(NOT tmp_content MATCHES "--DOC_NO_USAGE")
            set(DOC_PREFIX "@usage")
        endif()

        escape_string(
            " ${DOC_PREFIX}"
            "${TEST_DOC_CONTENT}" TEST_DOC_CONTENT ""
        )

        set(TEST_DOC_CONTENT "${TEST_DOC_CONTENT}${TEST_CODE}")
    endif()

    # Export the outout to the parent scope.
    set(${escaped_content} "${TEST_DOC_CONTENT}" PARENT_SCOPE)

endfunction()

# Find and run all test files.
file(GLOB_RECURSE test_files LIST_DIRECTORIES false
    "${SOURCE_DIR}/tests/examples/*.lua")
foreach(file ${test_files})
    if ((NOT "${file}" MATCHES ".*/shims/.*")
        AND (NOT "${file}" MATCHES ".*/template.lua"))

        file(RELATIVE_PATH relative_file "${SOURCE_DIR}" "${file}")
        message(STATUS "Running ${relative_file}...")

        # Get the file name without the extension.
        get_filename_component(TEST_FILE_NAME ${file} NAME_WE)

        get_namespace(namespace "${file}")

        run_test("${file}" "${namespace}" ESCAPED_CODE_EXAMPLE)

        # Set the test name.
        set(TEST_NAME DOC${namespace}_${TEST_FILE_NAME}_EXAMPLE)

        # Anything called @DOC_`namespace`_EXAMPLE@
        # in the Lua or C sources will be replaced by the content of that
        # variable during the pre-processing.
        # While at it, replace \" created by CMake by ',
        # &quot; wont work in <code>.
        string(REPLACE "\"" "'" ${TEST_NAME} ${ESCAPED_CODE_EXAMPLE})
    endif()
endforeach()

message(STATUS "Example tests passed.")

=== debian/changelog ===
awesome (4.0-1) unstable; urgency=medium

  * New upstream release. Closes: #850701, #851791.
    + d/patches:
      - Refreshed.
      - Drop Prevent_clients_from_being_lost_on_RANRD_changes.patch.
    + d/control:
      - Add B-D against libxcb-xrm-dev, libxcb-xkb-dev,
        libxkbcommon-x11-dev and libxkbcommon-dev.
      - Add B-D against lua-lgi (needed for docs/*.md).
    + d/docs: README renamed to README.md.
    + d/rules: Disable integration tests (currently fails).

 -- Arnaud Fontaine <arnau@debian.org>  Thu, 19 Jan 2017 15:25:32 +0900

=== debian/control ===
Source: awesome
Section: x11
Priority: optional
Maintainer: Julien Danjou <acid@debian.org>
Uploaders: Arnaud Fontaine <arnau@debian.org>
Build-Depends: debhelper (>= 9),
  libcairo2-dev,
  xmlto,
  asciidoc,
  cmake (>= 2.6.0),
  lua5.1,
  lua-ldoc,
  libxcb-xtest0-dev,
  libxcb-icccm4-dev (>= 0.3.8),
  libxcb-randr0-dev (>= 0.3.0),
  libxcb-keysyms1-dev (>= 0.3.4),
  libxcb-xinerama0-dev,
  liblua5.1-dev,
  libdbus-1-dev,
  libxdg-basedir-dev (>= 1.0.0),
  libstartup-notification0-dev (>= 0.10),
  imagemagick,
  libxcb1-dev (>= 1.6),
  libxcb-shape0-dev,
  libxcb-util0-dev,
  libxcb-cursor-dev (>= 0.1.0-2),
  libgdk-pixbuf2.0-dev,
  libglib2.0-dev,
  libxcb-xrm-dev,
  libxcb-xkb-dev,
  libxkbcommon-x11-dev,
  libxkbcommon-dev,
  lua-lgi (>= 0.7.0),
Standards-Version: 3.9.7
Homepage: http://awesome.naquadah.org
Vcs-Git: git://anonscm.debian.org/collab-maint/awesome.git
Vcs-Browser: http://anonscm.debian.org/git/collab-maint/awesome.git

Package: awesome
Architecture: any
Recommends: x11-xserver-utils, rlwrap, feh
Depends: ${shlibs:Depends},
  ${misc:Depends},
  menu,
  dbus-x11,
  lua-lgi (>= 0.7.0),
  gir1.2-freedesktop,
  gir1.2-pango-1.0
Provides: x-window-manager
Description: highly configurable X window manager
 awesome manages windows dynamically in floating or tiled layouts. It is
 primarily targeted at power users, developers, and all those dealing with
 everyday computing tasks and looking for fine-grained control over their
 graphical environment.
 .
 It is highly extensible and scriptable via the Lua programming language,
 providing an easy-to-use and very well documented API to configure its
 behavior.
 .
 awesome uses tags instead of workspaces, which gives better flexibility
 in displaying windows, and can be entirely keyboard-driven, not needing a
 mouse. It also supports multi-headed configurations; uses XCB instead of
 Xlib for better performance; implements many freedesktop standards; and
 can be controlled over D-Bus from awesome-client.

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -O--buildsystem=cmake -- -DSYSCONFDIR=/etc

override_dh_installwm:
	dh_installwm --priority=20 awesome

override_dh_auto_test:

## awesome 4.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,20 @@
 cmake_minimum_required(VERSION 3.0.0)
+project(awesome C)
+
+# Require an out-of-source build. We generate an awesomerc.lua in the build dir
+# from the one in the source dir and this does not work otherwise.
+if(CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_CURRENT_BINARY_DIR)
+    message(SEND_ERROR "\
+You appear to be doing an in-source build, which means that the binaries are \
+generated in the same directory where the source code is. This is currently not \
+supported. Instead, do, for example, the following:\n\
+   mkdir build && cd build && cmake ..\n\
+Beware that CMake likely already generated a CMakeCache.txt in the source \
+directory which you first have to delete. \
+")
+    message(FATAL_ERROR "In-source builds are not supported")
+endif()
+
 set(CMAKE_ALLOW_LOOSE_LOOP_CONSTRUCTS  TRUE)
 
 if(COMMAND cmake_policy)
@@ -23,9 +39,6 @@
     ${AWESOME_OPTIONAL_INCLUDE_DIRS})
 
 set(CHECK_TARGETS check-integration)
-
-set(AWE_CONF_FILE_DEFAULT ${BUILD_DIR}/awesomerc.lua)
-set(AWE_CONF_FILE rc.lua)
 
 set(AWE_ICON_DIR ${SOURCE_DIR}/icons)
 set(AWE_THEMES_DIR ${SOURCE_DIR}/themes)
@@ -281,10 +294,14 @@
     file(COPY ${SOURCE_DIR}/docs/aliases DESTINATION ${BUILD_DIR}/docs)
 
     add_custom_target(ldoc ALL
+        DEPENDS ${BUILD_DIR}/doc/index.html)
+    add_custom_command(
         COMMAND ${LDOC_EXECUTABLE} .
+        OUTPUT  ${BUILD_DIR}/doc/index.html
         WORKING_DIRECTORY ${AWE_DOC_DIR}
-        DEPENDS ${AWE_LUA_FILES} ${AWE_MD_FILES}
-    )
+        DEPENDS ${AWE_LUA_FILES} ${AWE_MD_FILES} ${BUILD_DIR}/docs/config.ld
+        COMMENT "Generating API documentation"
+        VERBATIM)
 
     # Run ldoc and make it fail if any warnings are generated. The
     # redirection-magic swaps stdout and stderr and awk exits with a non-zero
@@ -328,28 +345,3 @@
 
 foreach(icon ${ALL_ICONS})
     # Make unfocused icons translucent
-    a_icon_convert("_focus" "_normal" ${icon}
-        -colorspace rgb -gamma 0.6 -channel A -evaluate Multiply 0.4)
-endforeach()
-
-foreach(icon ${ALL_ICONS})
-    # Make inactive icons grayscale
-    a_icon_convert("_active" "_inactive" ${icon}
-        -colorspace Gray)
-endforeach()
-
-add_custom_target(generated_icons ALL DEPENDS ${ALL_ICONS})
-# }}}
-
-# {{{ Dist tarball
-if(BUILD_FROM_GIT)
-    add_custom_target(dist
-        COMMAND ${SOURCE_DIR}/build-utils/dist.sh ${VERSION}
-        WORKING_DIRECTORY ${SOURCE_DIR})
-endif()
-# }}}
-
-# {{{ Installation
-install(TARGETS ${PROJECT_AWE_NAME} RUNTIME DESTINATION bin)
-install(FILES "utils/awesome-client" DESTINATION bin PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)
-install(DIRECTORY ${BUILD_DIR}/lib DESTINATION ${AWESOME_DATA_PATH}

=== Makefile ===
ifeq (,$(VERBOSE))
    MAKEFLAGS:=$(MAKEFLAGS)s
    ECHO=echo
else
    ECHO=@:
endif

TARGETS=awesome
BUILDDIR=build

all: check-unit $(TARGETS) ;

$(TARGETS): cmake-build

$(BUILDDIR)/Makefile:
	$(ECHO) "Creating build directory and running cmake in it. You can also run CMake directly, if you want."
	$(ECHO)
	mkdir -p $(BUILDDIR)
	$(ECHO) "Running cmake…"
	cd $(BUILDDIR) && cmake $(CMAKE_ARGS) "$(@D)" ..

cmake-build: $(BUILDDIR)/Makefile
	$(ECHO) "Building…"
	$(MAKE) -C $(BUILDDIR)

tags:
	git ls-files | xargs ctags

install:
	$(ECHO) "Installing…"
	$(MAKE) -C $(BUILDDIR) install

distclean:
	$(ECHO) -n "Cleaning up build directory…"
	$(RM) -r $(BUILDDIR) $(TARGETS)
	$(ECHO) " done"

%: $(BUILDDIR)/Makefile
	$(ECHO) "Running make $@ in $(BUILDDIR)…"
	$(MAKE) -C $(BUILDDIR) $@

.PHONY: cmake-build install distclean tags

=== tests/examples/CMakeLists.txt ===
--- 
+++ 
@@ -14,20 +14,45 @@
 # Get and update the LUA_PATH so the scripts can be executed without Awesome.
 execute_process(COMMAND lua -e print\(package.path\) OUTPUT_VARIABLE "LUA_PATH_")
 
+# Make sure the system can be called from the test directory
+if(NOT SOURCE_DIR AND ${CMAKE_CURRENT_SOURCE_DIR} MATCHES "/tests/examples")
+    get_filename_component(TOP_SOURCE_DIR
+                           "${CMAKE_CURRENT_SOURCE_DIR}/../.." ABSOLUTE)
+    # Used by .luacov.
+    set(ENV{SOURCE_DIRECTORY} ${TOP_SOURCE_DIR})
+else()
+    set(TOP_SOURCE_DIR ${CMAKE_SOURCE_DIR})
+endif()
+
+if (DEFINED ENV{DO_COVERAGE} AND NOT $ENV{DO_COVERAGE} STREQUAL "0")
+  execute_process(
+    COMMAND lua -e "require('luacov.runner')('${TOP_SOURCE_DIR}/.luacov')"
+    RESULT_VARIABLE TEST_RESULT
+    ERROR_VARIABLE  TEST_ERROR
+    ERROR_STRIP_TRAILING_WHITESPACE)
+  if (TEST_RESULT OR NOT TEST_ERROR STREQUAL "")
+    message(${TEST_ERROR})
+    message(FATAL_ERROR "Failed to run luacov.runner.")
+  endif()
+  set(LUA_COV_RUNNER lua "-erequire('luacov.runner')('${TOP_SOURCE_DIR}/.luacov')")
+else()
+  set(LUA_COV_RUNNER lua)
+endif()
+
 # Add the main awesome lua libraries.
 set(LUA_PATH2_ "\
-${CMAKE_SOURCE_DIR}/lib/?.lua;\
-${CMAKE_SOURCE_DIR}/lib/?/init.lua;\
-${CMAKE_SOURCE_DIR}/lib/?;\
-${CMAKE_SOURCE_DIR}/themes/?.lua;\
-${CMAKE_SOURCE_DIR}/themes/?;"
+${TOP_SOURCE_DIR}/lib/?.lua;\
+${TOP_SOURCE_DIR}/lib/?/init.lua;\
+${TOP_SOURCE_DIR}/lib/?;\
+${TOP_SOURCE_DIR}/themes/?.lua;\
+${TOP_SOURCE_DIR}/themes/?;"
 )
 
 # Add the C API shims.
 set(LUA_PATH3_ "\
-${CMAKE_SOURCE_DIR}/tests/examples/shims/?.lua;\
-${CMAKE_SOURCE_DIR}/tests/examples/shims/?/init.lua;\
-${CMAKE_SOURCE_DIR}/tests/examples/shims/?;"
+${TOP_SOURCE_DIR}/tests/examples/shims/?.lua;\
+${TOP_SOURCE_DIR}/tests/examples/shims/?/init.lua;\
+${TOP_SOURCE_DIR}/tests/examples/shims/?;"
 )
 
 # Done in 3 variables to avoid CMake from implicitly converting into a list.
@@ -57,8 +82,8 @@
 
     set(tmp_output ${content})
     foreach (LINE ${var_lines})
-        if(NOT LINE MATCHES "^.+--DOC_[A-Z]+$")
-            set(tmp_output ${tmp_output}\n--${line_prefix}${LINE})
+        if(NOT LINE MATCHES "^.*--DOC_[A-Z]+")
+            set(tmp_output ${tmp_output}\n${DOC_LINE_PREFIX}${line_prefix}${LINE})
         endif()
     endforeach()
 
@@ -92,8 +117,8 @@
         endif()
     endforeach()
 
-    set(${post_output} "${tmp_post_output}\n--" PARENT_SCOPE)
-    set(${pre_output} "${tmp_pre_output}\n--" PARENT_SCOPE)
+    set(${post_output} "${tmp_post_output}\n${DOC_LINE_PREFIX}" PARENT_SCOPE)
+    set(${pre_output} "${tmp_pre_output}\n${DOC_LINE_PREFIX}" PARENT_SCOPE)
 endfunction()
 
 # Read a code file and convert it to ldoc usage example.
@@ -104,7 +129,7 @@
 function(escape_code path escaped_content pre_header post_header)
     file(READ ${path} path)
 
-    escape_string("${path}\n" "" escaped_code "")
+    escape_string("${path}\n" "" escaped_code " ")
 
     extract_header("${path}" example_pre_header example_post_header)
 
@@ -133,7 +158,7 @@
 # Get the namespace of a file.
 function(get_namespace result_variable file)
     get_filename_component(path "${file}" DIRECTORY)
-    string(LENGTH "${SOURCE_DIR}/tests/examples" prefix_length)
+    string(LENGTH "${TOP_SOURCE_DIR}/tests/examples" prefix_length)
     string(REPLACE "/" "_" namespace "${path}")
     string(SUBSTRING "${namespace}" "${prefix_length}" -1 namespace)
 
@@ -144,28 +169,40 @@
 function(run_test test_path namespace escaped_content)
     find_template(template "${test_path}")
 
+    file(READ ${test_path} tmp_content)
+
+    # Add "--" in front of each line. This is required for method doc, but not
+    # for documentation pages
+    if(NOT tmp_content MATCHES "--DOC_NO_DASH")
+        set(DOC_LINE_PREFIX "--")
+    endif()
+
+    # Do not use the @usage tag, but 4 spaces.
+    if(NOT tmp_content MATCHES "--DOC_NO_USAGE")
+        set(DOC_BLOCK_PREFIX "@usage")
+    endif()
+
     # Get the file name without the extension.
     get_filename_component(${test_path} TEST_FILE_NAME NAME)
     set(IMAGE_PATH "${IMAGE_DIR}/AUTOGEN${namespace}_${TEST_FILE_NAME}")
-
-    # Use the example testing as coverage source.
-    if (USE_LCOV)
-        set(LCOV_PATH ${SOURCE_DIR}/.luacov)
-    endif()
 
     # Execute the script, leave the image extension decision to the test.
     # SVG is preferred, but PNG is better suited for some tests, like bitmap
     # patterns.
     execute_process(
-        COMMAND lua ${template} ${test_path} ${IMAGE_PATH} ${LCOV_PATH}
+        COMMAND ${LUA_COV_RUNNER} ${template} ${test_path} ${IMAGE_PATH}
+        RESULT_VARIABLE TEST_RESULT
         OUTPUT_VARIABLE TEST_OUTPUT
         ERROR_VARIABLE  TEST_ERROR
     )
-
-    # If there is something on stderr, exit.
-    if (NOT TEST_ERROR STREQUAL "")
-        message("${TEST_OUTPUT}")
-        message("${TEST_ERROR}")
+    if (TEST_RESULT OR NOT TEST_ERROR STREQUAL "")
+        message("Result: ${TEST_RESULT}")
+        if (NOT TEST_OUTPUT STREQUAL "")
+            message("Output: ${TEST_OUTPUT}")
+        endif()
+        if (NOT TEST_ERROR STREQUAL "")
+            message("Error:  ${TEST_ERROR}")
+        endif()
         if (STRICT_TESTS)
             message(FATAL_ERROR ${test_path} " An example test failed, aborting.")
         endif()
@@ -194,7 +231,7 @@
     # documentation under the image.
     if(NOT ${TEST_OUTPUT} STREQUAL "")
         set(TEST_DOC_CONTENT
-            "${TEST_DOC_CONTENT}\n--\n--**Usage example output**:\n--"
+            "${TEST_DOC_CONTENT}\n${DOC_LINE_PREFIX}\n${DOC_LINE_PREFIX}**Usage example output**:\n${DOC_LINE_PREFIX}"
         )
 
         # Markdown requires an empty line before and after, and 4 spaces.
@@ -202,22 +239,16 @@
             "\n${TEST_OUTPUT}"
             "${TEST_DOC_CONTENT}" TEST_DOC_CONTENT "    "
         )
-        set(TEST_DOC_CONTENT "${TEST_DOC_CONTENT}\n--")
+        set(TEST_DOC_CONTENT "${TEST_DOC_CONTENT}\n${DOC_LINE_PREFIX}")
     endif()
 
     # If there is some @* content, append it.
     set(TEST_DOC_CONTENT "${TEST_DOC_CONTENT}${TEST_POST_HEADER}")
 
     # Only add it if there is something to display.
-    if(NOT ${TEST_CODE} STREQUAL "\n--")
-        # Do not use the @usage tag, but 4 spaces.
-        file(READ ${test_path} tmp_content)
-        if(NOT tmp_content MATCHES "--DOC_NO_USAGE")
-            set(DOC_PREFIX "@usage")
-        endif()
-
-        escape_string(
-            " ${DOC_PREFIX}"
+    if(NOT ${TEST_CODE} STREQUAL "\n${DOC_LINE_PREFIX}")
+        escape_string(
+            " ${DOC_BLOCK_PREFIX}"
             "${TEST_DOC_CONTENT}" TEST_DOC_CONTENT ""
         )
 
@@ -231,12 +262,12 @@
 
 # Find and run all test files.
 file(GLOB_RECURSE test_files LIST_DIRECTORIES false
-    "${SOURCE_DIR}/tests/examples/*.lua")
+    "${TOP_SOURCE_DIR}/tests/examples/*.lua")
 foreach(file ${test_files})
     if ((NOT "${file}" MATCHES ".*/shims/.*")
         AND (NOT "${file}" MATCHES ".*/template.lua"))
 
-        file(RELATIVE_PATH relative_file "${SOURCE_DIR}" "${file}")
+        file(RELATIVE_PATH relative_file "${TOP_SOURCE_DIR}" "${file}")
         message(STATUS "Running ${relative_file}...")
 
         # Get the file name without the extension.
@@ -259,3 +290,5 @@
 endforeach()
 
 message(STATUS "Example tests passed.")
+
+# vim: filetype=cmake:expandtab:shiftwidth=4:tabstop=8:softtabstop=4:textwidth=80:foldmethod=marker

=== debian/changelog ===
awesome (4.2-4) unstable; urgency=medium

  * Support for freedesktop.org menu. (Closes: #693135)
    - patch default awesomerc.lua to load/use freedesktop module if available
    - recommend awesome-extra, which includes freedesktop module
    - document change in NEWS
  * Fix formatting, spelling and urgency in NEWS.
  * Add libcairo-gobject2 to dependencies. (LP: #1589709)
  * Bump debhelper compatibility/dependency to 11.
  * Bump Standards-Version to 4.1.2.
  * Mention another way of customization in README.Debian. (Closes: #527115)

 -- Reiner Herrmann <reiner@reiner-h.de>  Wed, 27 Dec 2017 15:44:59 +0100

awesome (4.2-3) unstable; urgency=medium

  * Inform about switch to lua 5.3 in NEWS. (Closes: #880143)
  * Bump lua-lgi dependency to 0.9.2; older versions are broken on big endian
    64bit architectures like s390x. (Closes: #879941)

 -- Reiner Herrmann <reiner@reiner-h.de>  Sun, 05 Nov 2017 12:12:19 +0100

awesome (4.2-2) unstable; urgency=low

  * New maintainer. (Closes: #867316)
  * Build against lua 5.3.
  * Update menu-method generator for lua 5.3.
  * Allow other session bus than dbus-x11. (Closes: #836080)
  * Move API documentation into -doc package. (Closes: #546688)
  * Remove ancient version restrictions.
  * Cherry-pick upstream fix for errors with keyboardlayout widget.
    (Closes: #877757)
  * Document copyright of wallpaper images in default theme.
  * Run unit tests during build.
    - add lua-busted and zsh to build dependencies.
  * Run integration tests as autopkgtest.

 -- Reiner Herrmann <reiner@reiner-h.de>  Mon, 23 Oct 2017 19:20:04 +0200

awesome (4.2-1) unstable; urgency=medium

  * QA upload.

  [ Reiner Herrmann ]
  * New upstream release (Closes: #858170).
  * debian/control:
    - bump Standards-Version to 4.1.1
    - update Homepage field
    - change Vcs-* URLs to https
  * Add upstream signing key.
  * Check upstream signature in watch file.
  * Fix spelling error found by lintian.
  * Register API documentation at doc-base.
  * Amend desktop file with Icon and Keywords entries.
  * Enable all hardening options.
  * Drop build status from documentation to remove privacy breach.
  * Sort table in documentation to build it reproducibly.
  * Honour SOURCE_DATE_EPOCH in generated images in documentation
    of calendar widget.
  * Add myself to debian/copyright.

  [ Julian Wollrath ]
  * Update build dependencies.
  * Bump required lua-lgi version to at least 0.8.0 (Closes: #852969).
  * Drop remove_useless_build_lgi_check.patch.
  * Refresh install-and-debian-menu.
  * Provide notification-daemon. (Closes: #734645)
  * Do not install README.md link. (Closes: #856442)

  [ Nicolas Boulenguez ]
  * Orphan the package (see #867316).
  * Run wrap-and-sort.
  * Stop overriding dh_installwm, priority 20 is the default.
  * Let watch file track github tags.
  * Switch to debhelper 10.
  * Switch to copyright format 1.0. Order like docs/00-authors.md.
  * Generate menu icon during build.

  [ Łukasz Stelmach ]
  * Add support for starting other window managers in Debian menu.
    (Closes: #856476)

 -- Reiner Herrmann <reiner@reiner-h.de>  Mon, 02 Oct 2017 23:57:00 +0200

=== debian/control ===
Source: awesome
Section: x11
Priority: optional
Maintainer: Reiner Herrmann <reiner@reiner-h.de>
Build-Depends: asciidoc,
               cmake,
               debhelper (>= 11),
               imagemagick,
               libcairo2-dev,
               libdbus-1-dev,
               libgdk-pixbuf2.0-dev,
               libglib2.0-dev,
               liblua5.3-dev,
               libpango1.0-dev,
               libstartup-notification0-dev,
               libx11-xcb-dev,
               libxcb-cursor-dev,
               libxcb-icccm4-dev,
               libxcb-keysyms1-dev,
               libxcb-randr0-dev,
               libxcb-shape0-dev,
               libxcb-util0-dev,
               libxcb-xinerama0-dev,
               libxcb-xkb-dev,
               libxcb-xrm-dev,
               libxcb-xtest0-dev,
               libxdg-basedir-dev,
               libxkbcommon-dev,
               libxkbcommon-x11-dev,
               lua-busted,
               lua-discount,
               lua-ldoc,
               lua-lgi (>= 0.9.2),
               lua5.3,
               x11proto-core-dev,
               xmlto,
               zsh
Standards-Version: 4.1.2
Homepage: https://awesomewm.org/
Vcs-Git: https://anonscm.debian.org/git/collab-maint/awesome.git
Vcs-Browser: https://anonscm.debian.org/git/collab-maint/awesome.git

Package: awesome
Architecture: any
Recommends: feh, rlwrap, x11-xserver-utils, awesome-extra
Suggests: awesome-doc
Depends: default-dbus-session-bus | dbus-session-bus,
         gir1.2-freedesktop,
         gir1.2-pango-1.0,
         libcairo-gobject2,
         lua-lgi (>= 0.9.2),
         menu,
         ${misc:Depends},
         ${shlibs:Depends}
Provides: notification-daemon, x-window-manager
Description: highly configurable X window manager
 awesome manages windows dynamically in floating or tiled layouts. It is
 primarily targeted at power users, developers, and all those dealing with
 everyday computing tasks and looking for fine-grained control over their
 graphical environment.
 .
 It is highly extensible and scriptable via the Lua programming language,
 providing an easy-to-use and very well documented API to configure its
 behavior.
 .
 awesome uses tags instead of workspaces, which gives better flexibility
 in displaying windows, and can be entirely keyboard-driven, not needing a
 mouse. It also supports multi-headed configurations; uses XCB instead of
 Xlib for better performance; implements many freedesktop standards; and
 can be controlled over D-Bus from awesome-client.

Package: awesome-doc
Architecture: all
Section: doc
Multi-Arch: foreign
Depends: ${misc:Depends}
Replaces: awesome (<< 4.2-2)
Breaks: awesome (<< 4.2-2)
Description: highly configurable X window manager - documentation
 awesome manages windows dynamically in floating or tiled layouts. It is
 primarily targeted at power users, developers, and all those dealing with
 everyday computing tasks and looking for fine-grained control over their
 graphical environment.
 .
 It is highly extensible and scriptable via the Lua programming language,
 providing an easy-to-use and very well documented API to configure its
 behavior.
 .
 awesome uses tags instead of workspaces, which gives better flexibility
 in displaying windows, and can be entirely keyboard-driven, not needing a
 mouse. It also supports multi-headed configurations; uses XCB instead of
 Xlib for better performance; implements many freedesktop standards; and
 can be controlled over D-Bus from awesome-client.
 .
 This package contains the API documentation for awesome.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=cmake --builddirectory=build

override_dh_auto_configure: debian/awesome.xpm
	dh_auto_configure -- -DSYSCONFDIR=/etc

debian/awesome.xpm: icons/awesome32.png
	convert $< $@

override_dh_auto_test:
	# run unit tests here.
	# the generic check target also runs integration tests,
	# which are better suited as autopkgtest.
	$(MAKE) -C build check-unit

=== debian/tests/control ===
# lua5.2 is explicitely added, because 5.3 doesn't currently provide lua (#863036)
Tests: integration.sh
Depends: awesome, lua5.2, xvfb, dbus-x11, xterm, xfonts-base, x11-xserver-utils, x11-utils, gir1.2-gtk-3.0, build-essential, libxcb1-dev, libxcb-util0-dev, libxcb-icccm4-dev
